#ifndef QCOLORWIDGET_H
#define QCOLORWIDGET_H

#include <QtGui/QWidget>

class QColorWidget : public QWidget
{
    Q_OBJECT
public:
    QColorWidget(QWidget *parent = 0);
	QColor color() const;
protected:
	void mousePressEvent(QMouseEvent *);
	void paintEvent(QPaintEvent *);
private:
	QColor propColor;
signals:
	void colorChanged(QColor);
};

#endif
