#ifndef BSPLINE_H
#define BSPLINE_H

#include "curva.h"

class BSpline: public Curva
{
public:
    BSpline(std::string nome, std::vector<Coordenada> pontos, Cor cor = Cor(0,0,0) );
    virtual std::string tipo() const;
    virtual Objeto* clonar() const;
private:
    virtual std::vector<Polinomio> obterPolinomios();
};


#include "fabricadeobjeto.h"

FabricaDeObjeto* obterFabricaDeBSpline();
#endif // BSPLINE_H
