#ifndef BSPLINE3D_H
#define BSPLINE3D_H

#include "curva3d.h"

class BSpline3D: public Curva3D
{
public:
    BSpline3D(std::string nome, std::vector<Geometria>, Cor cor = Cor(0.0,0.0,0.0) );

    virtual std::string tipo() const;
    virtual Objeto* clonar() const;
private:
    std::vector<Matriz<4,4> > aplicarMatriz(Geometria) const;
};

#endif // BSPLINE3D_H
