#ifndef ESTRATEGIAPUEL_H
#define ESTRATEGIAPUEL_H

#include "clipping/estrategiapoligono.h"

class EstrategiaPuel : public EstrategiaPoligono
{
public:
	virtual std::vector<Coordenada> clipar(const std::vector<Coordenada>& poligono, Window*) const;
public:
	char regiaoExclusiva(const Coordenada&, Window*) const;
	char regiaoExclusivaNaBorda(const Coordenada&, Window*) const;
	Coordenada puxar(const Coordenada&, int regiao, Window*) const;
	char regiaoContraria(char) const;
};

#endif // ESTRATEGIAPUEL_H
