#include "fabricadeobjeto.h"

FabricaDeObjeto::FabricaDeObjeto() {
	String* nome = new String();
	nome->label = "Nome";
	_opcoes.push_back(nome);

	Coordenadas* coordenadas = new Coordenadas();
	coordenadas->label = "Coordenadas";
	coordenadas->owner = this;
	_opcoes.push_back(coordenadas);

	Color* cor = new Color();
	cor->label = "Cor";
	_opcoes.push_back(cor);
}

FabricaDeObjeto::~FabricaDeObjeto() {
	delete _opcoes.at(0);
	delete _opcoes.at(1);
	delete _opcoes.at(2);
}

FabricaDeObjeto::Options FabricaDeObjeto::opcoes() {
	((String*)_opcoes.at(0))->value = "";
	((Coordenadas*)_opcoes.at(1))->value.clear();
	((Color*)_opcoes.at(2))->value = Cor();
	return _opcoes;
}

std::map<std::string, FabricaDeObjeto*> FabricaDeObjeto::fabricas;
