#ifndef __PONTO_H
#define __PONTO_H

#include "objetoclipavel.h"

class Ponto: public ObjetoClipavel {
public:
	Ponto(std::string nome, Coordenada coordenada, Cor cor = Cor(0,0,0));
	virtual ~Ponto();

	virtual void persist(TiXmlNode*) const;
	virtual void restore(TiXmlElement*);

	virtual void recalcularCache(Window* clipador);

	virtual std::string tipo() const;
	virtual Objeto* clonar() const;

};

#include "fabricadeobjeto.h"

FabricaDeObjeto* obterFabricaDePonto();

#endif
