#include "window.h"
#include "objeto.h"
#include "reta.h"
#include "ponto.h"
#include "poligono.h"

#include <iostream>
std::ostream &operator<<(std::ostream& stream, Coordenada coordenada){
	stream << "Coordenada(" << coordenada.x() << ',' << coordenada.y() << ',' << coordenada.z() << ")";
	return stream;
}

#include <boost/test/unit_test.hpp>

BOOST_AUTO_TEST_SUITE( testes )
BOOST_AUTO_TEST_SUITE( objeto )

BOOST_AUTO_TEST_CASE( testeCentroDaWindow ) {
	Window minhaWindow(Coordenada(-10.0,-10.0), Coordenada(10.0,10.0), Coordenada(0.0,0.0,-10.0));
	BOOST_CHECK_EQUAL(Coordenada(0.0,0.0), minhaWindow.centro());
}

BOOST_AUTO_TEST_CASE( testeClonarObjetos ) {
//	std::vector<Coordenada> pontosDoPoligono;
//	pontosDoPoligono.push_back(Coordenada(-3.0,-3.0));
//	pontosDoPoligono.push_back(Coordenada(0.0,0.0));
//	pontosDoPoligono.push_back(Coordenada(3.0,-3.0));
//	Objeto* poligono = new Poligono("Ola", pontosDoPoligono, Cor(255,0,0));
//	Objeto* ponto = new Ponto("Ola2", Coordenada(0.0,0.0), Cor(0,255,0));
//	Objeto* reta = new Reta("Ola3", Coordenada(2.0,1.0), Coordenada(1.0,2.0), Cor(0,0,255));
//	Objeto* poligonoClonado = poligono->clonar();
//	Objeto* pontoClonado = ponto->clonar();
//	Objeto* retaClonada = reta->clonar();
//
//	QVERIFY(poligonoClonado != poligono);
//	QCOMPARE(poligonoClonado->nome(), poligono->nome());
//	QCOMPARE(poligonoClonado->coordenadas().size(), poligono->coordenadas().size());
//	QCOMPARE(poligonoClonado->coordenadas()[0], poligono->coordenadas()[0]);
//	QCOMPARE(poligonoClonado->coordenadas()[1], poligono->coordenadas()[1]);
//	QCOMPARE(poligonoClonado->coordenadas()[2], poligono->coordenadas()[2]);
//	QCOMPARE(poligonoClonado->coordenadas()[3], poligono->coordenadas()[3]);
//	QCOMPARE(poligonoClonado->cor(), poligono->cor());
//
//	QVERIFY(pontoClonado != ponto);
//	QCOMPARE(pontoClonado->nome(), ponto->nome());
//	QCOMPARE(pontoClonado->coordenadas().size(), ponto->coordenadas().size());
//	QCOMPARE(pontoClonado->coordenadas()[0], ponto->coordenadas()[0]);
//	QCOMPARE(pontoClonado->cor(), ponto->cor());
//
//	QVERIFY(retaClonada != reta);
//	QCOMPARE(retaClonada->nome(), reta->nome());
//	QCOMPARE(retaClonada->coordenadas().size(), reta->coordenadas().size());
//	QCOMPARE(retaClonada->coordenadas()[0], reta->coordenadas()[0]);
//	QCOMPARE(retaClonada->coordenadas()[1], reta->coordenadas()[1]);
//	QCOMPARE(retaClonada->cor(), reta->cor());
}

BOOST_AUTO_TEST_SUITE_END()
BOOST_AUTO_TEST_SUITE_END()
