#include "coordenada.h"
#include "ponto.h"
#include "reta.h"
#include "poligono.h"
#include <boost/test/unit_test.hpp>

BOOST_AUTO_TEST_SUITE( testes )
BOOST_AUTO_TEST_SUITE( transformada )

BOOST_AUTO_TEST_CASE( testeTranslacao ){
//        Ponto pontinho("ponto", Coordenada(0.0,0.0));
//        Reta retinha("reta", Coordenada(-1.0,-1.0), Coordenada(1.0,1.0));
//        std::vector<Coordenada> pontos;
//        pontos.push_back(Coordenada(10.0,10.0));
//        pontos.push_back(Coordenada(10.0,13.0));
//        pontos.push_back(Coordenada(14.0,10.0));
//        Poligono poligoninho("poligono", pontos);
//	Matriz<3,3> translacao = Matriz<3,3>::translacao(10,5);
//
//	pontinho.aplicarTransformacao(translacao);
//	retinha.aplicarTransformacao(translacao);
//	poligoninho.aplicarTransformacao(translacao);
//
//        Coordenada doPontinho = pontinho.coordenadas().front();
//        Coordenada origemRetinha = retinha.coordenadas().front();
//        Coordenada fimRetinha = retinha.coordenadas().back();
//
//	Coordenada poligonoUm = poligoninho.coordenadas().at(0);
//	Coordenada poligonoDois = poligoninho.coordenadas().at(1);
//	Coordenada poligonoTres = poligoninho.coordenadas().at(2);
//
//	COMPARAR(doPontinho.x(), 10.0);
//	COMPARAR(doPontinho.y(), 5.0);
//
//	COMPARAR(origemRetinha.x(), 9.0);
//	COMPARAR(origemRetinha.y(),4.0);
//	COMPARAR(fimRetinha.x(), 11.0);
//	COMPARAR(fimRetinha.y(), 6.0);
//
//	COMPARAR(poligonoUm.x(), 20.0);
//	COMPARAR(poligonoUm.y(), 15.0);
//	COMPARAR(poligonoDois.x(), 20.0);
//	COMPARAR(poligonoDois.y(), 18.0);
//	COMPARAR(poligonoTres.x(), 24.0);
//	COMPARAR(poligonoTres.y(), 15.0);
}

BOOST_AUTO_TEST_CASE( testeEscala ){
//    Ponto pontinho("ponto", Coordenada(2.0,3.0));
//
//    std::vector<Coordenada> pontos;
//    pontos.push_back(Coordenada(-1.0,-1.0));
//    pontos.push_back(Coordenada(1.0,-1.0));
//    pontos.push_back(Coordenada(-1.0,1.0));
//    pontos.push_back(Coordenada(1.0,1.0));
//    Poligono poligoninho("poligono", pontos);
//
//    Matriz<3,3> transformacao = Matriz<3,3>::escala(2,2);
//
//    pontinho.aplicarTransformacao(transformacao);
//    poligoninho.aplicarTransformacao(transformacao);
//
//    Coordenada doPonto = pontinho.coordenadas().front();
//
//    Coordenada poligonoUm = poligoninho.coordenadas()[0];
//    Coordenada poligonoDois = poligoninho.coordenadas()[1];
//    Coordenada poligonoTres = poligoninho.coordenadas()[2];
//    Coordenada poligonoQuatro = poligoninho.coordenadas()[3];
//
//	COMPARAR(doPonto.x(), 4.0);
//	COMPARAR(doPonto.y(), 6.0);
//
//	COMPARAR(poligonoUm.x(), -2.0);
//	COMPARAR(poligonoUm.y(), -2.0);
//	COMPARAR(poligonoDois.x(), 2.0);
//	COMPARAR(poligonoDois.y(), -2.0);
//	COMPARAR(poligonoTres.x(), -2.0);
//	COMPARAR(poligonoTres.y(), 2.0);
//	COMPARAR(poligonoQuatro.x(), 2.0);
//	COMPARAR(poligonoQuatro.y(), 2.0);
}

BOOST_AUTO_TEST_CASE( testeRotacao ) {
	Ponto pontinho("ponto", Coordenada(3.0,0.0));

	std::vector<Coordenada> pontos;
	pontos.push_back(Coordenada(-1.0,-1.0));
	pontos.push_back(Coordenada(1.0,-1.0));
	pontos.push_back(Coordenada(-1.0,1.0));
	pontos.push_back(Coordenada(1.0,1.0));
	Poligono poligoninho("poligono", pontos);

	Transformacao transformacao = Transformacao::rotacao(-90);

	pontinho.aplicarTransformacao(transformacao);
	poligoninho.aplicarTransformacao(transformacao);

//    Coordenada doPonto = pontinho.coordenadas().front();
//
//    Coordenada poligonoUm = poligoninho.coordenadas()[0];
//    Coordenada poligonoDois = poligoninho.coordenadas()[1];
//    Coordenada poligonoTres = poligoninho.coordenadas()[2];
//    Coordenada poligonoQuatro = poligoninho.coordenadas()[3];
//
//	COMPARAR(doPonto.x(), 0.0);
//	COMPARAR(doPonto.y(), 3.0);
//
//	COMPARAR(poligonoUm.x(), 1.0);
//	COMPARAR(poligonoUm.y(), -1.0);
//	COMPARAR(poligonoDois.x(), 1.0);
//	COMPARAR(poligonoDois.y(), 1.0);
//	COMPARAR(poligonoTres.x(), -1.0);
//	COMPARAR(poligonoTres.y(), -1.0);
//	COMPARAR(poligonoQuatro.x(), -1.0);
//	COMPARAR(poligonoQuatro.y(), 1.0);

}

BOOST_AUTO_TEST_CASE( testeTranslacaoSeguida ){
//	Ponto ponto("pontinho", Coordenada(0.0,0.0));
//    Matriz<3,3> transformacao = Matriz<3,3>::translacao(1,1);
//
//    for(double i = 1; i < 100; i++){
//	ponto.aplicarTransformacao(transformacao);
//	Coordenada doPonto = ponto.coordenadas().front();
//	QCOMPARE(doPonto.x(), i);
//	QCOMPARE(doPonto.y(), i);
//    }
}

BOOST_AUTO_TEST_CASE( testeRotacaoExaustiva ){
//	Ponto meuPonto("pontinho", Coordenada(10.0,7.0));
//	Matriz<COORDENADA_LARGURA, COORDENADA_LARGURA> rodar = Matriz<COORDENADA_LARGURA,COORDENADA_LARGURA>::rotacao(10.0);
//	for(int i=0;i<3600;i++){
//		meuPonto.aplicarTransformacao(rodar);
//	}
//	Coordenada doPontinho = meuPonto.coordenadas().front();
//	COMPARAR(10.0, doPontinho.x());
//	COMPARAR(7.0, doPontinho.y());
}

BOOST_AUTO_TEST_SUITE_END()
BOOST_AUTO_TEST_SUITE_END()
