#ifndef QVIEWPORT_H
#define QVIEWPORT_H

#include <QWidget>
#include <QPainter>
#include "viewport.h"

class QViewport : public Viewport, public QWidget
{
public:
	QViewport ( QWidget * parent = 0);
	virtual ~QViewport();

	int altura(){
		return height();
	}
	int largura(){
		return width();
	}

protected:
	void iniciarPintura();
	void repintar0(Objeto*);
	void repintar1(Objeto*);
	void repintar2(Objeto*);
	void pintarInformacoes(Objeto*);
	void finalizarPintura();

	void paintEvent(QPaintEvent *);
private:
	QPainter pintor;
};

#endif // QVIEWPORT_H
