#ifndef BEZIER3D_H
#define BEZIER3D_H

#include "curva3d.h"

class Bezier3D: public Curva3D
{
public:
    Bezier3D(std::string nome, std::vector<Geometria>, Cor cor = Cor(0.0,0.0,0.0) );
    virtual std::string tipo() const;
    virtual Objeto* clonar() const;
            
private:
    std::vector<Matriz<4,4> > aplicarMatriz(Geometria) const;
};

#endif // BEZIER3D_H
