#ifndef COR_H
#define COR_H

#include <string>
#include <QColor>

class Cor{
public:
	Cor(int red=0, int green=0, int blue=0);
    Cor(const QColor&);
	Cor(const std::string& hex);
    virtual ~Cor();
    QColor qcolor();

    int red() const;
    int green() const;
    int blue() const;
    void red(const int&);
    void green(const int&);
    void blue(const int&);

	std::string hex() const;

	bool operator==(const Cor&) const;

private:
    int _red, _green, _blue;
};


#endif // COR_H
