#ifndef CURVA_H
#define CURVA_H

#include "objetoclipavel.h"


class Curva: public ObjetoClipavel
{
public:
    typedef Matriz<4,3> Polinomio;

    Curva(std::string nome, std::vector<Coordenada> pontos, Cor cor = Cor(0,0,0) );
    virtual ~Curva();
    virtual std::string tipo() const;

    virtual void recalcularCache(Window* clipador);

    virtual Objeto* clonar() const =0 ;
private:
	virtual std::vector<Polinomio> obterPolinomios() =0 ;
};


#endif // CURVA_H
