#ifndef DISPLAYFILE_H
#define DISPLAYFILE_H

#include <vector>
#include "objeto.h"
#include "coordenada.h"
#include "transformacao.h"

class DisplayFile : public std::vector<Objeto*>
{
public:
    DisplayFile();
    virtual ~DisplayFile();

	void persist(TiXmlNode*) const;
	void restore(TiXmlNode*);

	Coordenada menorPonto() const;
	Coordenada maiorPonto() const;

	void aplicarTransformacao(const Transformacao&);

	DisplayFile clonarObjetos() const;
};

#endif // DISPLAYFILE_H
