#ifndef __RETA_H
#define __RETA_H

#include "objetoclipavel.h"
#include "clipping/estrategiareta.h"

class Reta: public ObjetoClipavel {
public:
	Reta(std::string nome, Coordenada origem, Coordenada destino, Cor cor = Cor(0,0,0));
	virtual ~Reta();
	virtual std::string tipo() const;
	virtual void recalcularCache(Window* clipador);

	virtual Objeto* clonar() const;
private:
	EstrategiaReta* _estrategia;
};

#include "fabricadeobjeto.h"

FabricaDeObjeto* obterFabricaDeReta();


#endif
