#ifndef NOVOOBJETO_H
#define NOVOOBJETO_H

#include <QDialog>
#include <vector>
#include "libcg/fabricadeobjeto.h"

namespace Ui {
    class NovoObjeto;
}

class NovoObjeto : public QDialog {
    Q_OBJECT
public:
    NovoObjeto(QWidget *parent = 0);
    ~NovoObjeto();
	FabricaDeObjeto* obterTipo() const;
	QWidget* generateOptionsUi();

protected:
    void changeEvent(QEvent *e);

private:
	QWidget* ultimo;
	FabricaDeObjeto::Options options;
	Ui::NovoObjeto *ui;
	std::vector<FabricaDeObjeto*> tiposDeObjetos;

private slots:
	void on_tipo_currentIndexChanged(QString );
	void optionValueChanged();

};

#endif // NOVOOBJETO_H

